program define iso_concordia2

version 10

	display
	display
	display
	display as text". ISOTOOLS by F. Bea; v. 3.0 (20 Jun 2008)"
	display
	display as text". Wetherill Concordia Plot and Age Calculations"
	display
	display
	
	/*checking if neccessary variables are present*/
	capture confirm string variable id
	if _rc~=0 {
		display as error". YOU DO NOT HAVE A STRING VARIABLE NAMED -id-"
		exit
	}
	capture confirm numeric variable pb7_pb6
	if _rc~=0 {
		display as error". YOU DO NOT HAVE A NUMERIC VARIABLE NAMED pb7_pb6"
		exit
	}
	capture confirm numeric variable pb6_u8
	if _rc~=0 {
		display as error". YOU DO NOT HAVE A NUMERIC VARIABLE NAMED pb6_u8"
		exit
	}
	capture confirm numeric variable u_ppm
	if _rc~=0 {
		display as error". YOU DO NOT HAVE A NUMERIC VARIABLE NAMED u_ppm. I cann't correct for U excess"
		local u_correct=0
	}
	else{
		local u_correct=1
		capture confirm numeric variable flag_4cor
		if _rc~=0 {
		gen flag_4cor=0
		}
	}	
	capture confirm numeric variable flag_uexcesscor
	if _rc~=0 {
	gen flag_uexcesscor=0
	}
/*end of checking if neccessary variables are present*/

local ndata=_N
/* U excess correction, according to Ian Williams*/ 
quietly{
 	if `u_correct'==1{
 		if flag_uexcesscor~=1{
 			replace flag_uexcesscor=0 if flag_uexcesscor~=1
 			replace pb6_u8=pb6_u8*(1-0.02*(u_ppm-2500)/1000) if u_ppm>2500 & flag_uexcesscor==0
 			replace flag_uexcesscor=1 if u_ppm>2500
 		}/* del if flag_uexcesscor*/
 	}/*del if u_correct*/ 	
 }/*del quietly*/	
/*end U excess correction*/


/*204 correction*/
local correction_204 "n"
capture confirm numeric variable pb4_pb6
	if _rc==0 {
		capture confirm string `correction_204'
		if _rc!=0 {
             display as result". Shall I correct common lead according to measured 204/206? (y/n) " _cont
             display _request(_correction_204)
             }
             quietly{
             if  "`correction_204'"=="y" {
    
             		replace flag_4cor=1
             		capture drop pb7_pb6_4cor
             		capture drop pb8_pb6_4cor
             		capture drop pb6_u8_4cor
             		capture drop pb8_th_4cor
             		gen pb7_pb6_4cor=.
             		gen pb8_pb6_4cor=.
             		gen pb6_u8_4cor=.
             		gen pb8_th_4cor=.
             		global age 0
					global i 0
					global pb208 0
					global pb204 0

				while $i<[_N] {/*while 1*/
						global i=$i +1
						global pb207=pb7_pb6[$i]
						global pb208=pb8_pb6[$i]
						global pb204=pb4_pb6[$i]
						global t_pbpb=0	
						t_pbpb $pb207					
						local control=$t_pbpb*2
						while int($t_pbpb*10) !=int(`control'*10) {/*while2*/
							local control=$t_pbpb 
							sk	$pb207 $pb208 $pb204	
							t_pbpb $pb207_4cor
						}/*del while 2*/
				
					replace pb7_pb6_4cor= $pb207_4cor in $i
					replace pb8_pb6_4cor= $pb208_4cor in $i
					replace pb6_u8_4cor=$pb6_u8_4cor in $i
					replace pb8_th_4cor=$pb8_th_4cor in $i
				 }/*del while 1*/
			 }/* if de la correction_204*/
			 else {
			 		capture drop flag_4cor
			 		gen flag_4cor=0
			 		}
			 	}/*del quietly*/	
 		}/*del primer if*/
 /*end 204 correction*/
 
 /* calculos*/
	local graph_title "Wetherill plot. Common-lead uncorrected"
	if  "`correction_204'"=="y" {
		quietly{
			capture drop pb7_pb6_uncor pb6_u8_uncor pb8_th_uncor
			gen pb7_pb6_uncor=pb7_pb6
			gen pb6_u8_uncor=pb6_u8
			gen pb8_th_uncor=pb8_th
			replace pb7_pb6=pb7_pb6_4cor
			replace pb6_u8=pb6_u8_4cor
			replace pb8_th=pb8_th_4cor
			local graph_title "Wetherill plot. 204-corrected"
			}/*del quietly*/
		}

quietly{
	drop if id=="to_plot"
	}
	capture drop caso t_plot label
	capture drop u8_pb6 u5_pb7 pb7_u5 th_pb8
	capture drop t_u8_pb6 t_pb7_pb6 t_u5_pb7 t_th_pb8
	capture drop t_u8_pb6_4cor t_pb7_pb6_4cor t_u5_pb7_4cor t_th_pb8_4cor
	capture drop hi_pb7_pb6 lo_pb7_pb6 hi_u8_pb6 lo_u8_pb6
	capture drop err_t_u8_pb6 err_t_u5_pb7 err_t_th_pb8 err_t_pb7_pb6 
	capture drop hi_pb6_u8 lo_pb6_u8 hi_pb7_u5 lo_pb7_u5 alfa lo_a lo_b hi_a hi_b hi_b
	capture	drop hi_pb7_pb6 lo_pb7_pb6 hi_u8_pb6 lo_u8_pb6
	
quietly{/*calcula el resto de las relaciones isotpicas*/
	gen u8_pb6=1/pb6_u8 
	gen u5_pb7=(0.72/99.2743)*u8_pb6/pb7_pb6
	gen pb7_u5=1/u5_pb7
	gen th_pb8=1/pb8_th
	}

local ndata=_N

local aspect_ratio=0.7 /*es necesario definirlo para calcular correctamente las barras de error inclinadas*/

quietly { /*los mximos y minimos para calcular los errores*/
	gen hi_pb7_pb6=pb7_pb6*(1+err_pb7_pb6/100)
	gen lo_pb7_pb6=pb7_pb6*(1-err_pb7_pb6/100)
	gen hi_u8_pb6=u8_pb6*(1+err_pb6_u8/100)
	gen lo_u8_pb6=u8_pb6*(1-err_pb6_u8/100)
	}

	
quietly {/*comienza el calculo de edades*/
			gen t_u8_pb6=(10000/1.55125)*log(1+1/u8_pb6)
			gen err_t_u8_pb6=t_u8_pb6-(10000/1.55125)*log(1+1/(u8_pb6*(1+err_pb6_u8/100)))
			gen t_u5_pb7=(10000/9.8485)*log(1+1/u5_pb7)
			gen err_t_u5_pb7=t_u5_pb7-(10000/9.8485)*log(1+1/(u5_pb7*(1+err_pb6_u8/100)))
			gen t_th_pb8=(100000/4.9475)*log(1+1/th_pb8)
			gen err_t_th_pb8=t_th_pb8-(100000/4.9475)*log(1+1/(th_pb8*(1+err_pb8_th/100)))

			gen float t_pb7_pb6=0 /*las edades pb7_pb6*/
			forvalues i=1(1)`ndata' {
				global pbpb=pb7_pb6[`i']
				t_pbpb $pbpb
				replace t_pb7_pb6 = $t_pbpb in `i'
				}/*del forvalues*/
			gen float err_t_pb7_pb6=0 /*los errores en las edades pb7_pb6*/
			forvalues i=1(1)`ndata' {
				global pbpb=lo_pb7_pb6[`i']
				t_pbpb $pbpb
				replace err_t_pb7_pb6 = t_pb7_pb6[`i']-$t_pbpb in `i'
			}/*del forvalues*/

			/*207 correction*/
		if  "`correction_204'"~="y" {
				capture drop t_u8_pb6_7cor err_t_u8_pb6_7cor
				gen float t_u8_pb6_7cor=0 	/*las edades corregidas de Pb comun con 207*/
				forvalues i=1(1)`ndata' {
					global t_upb=t_u8_pb6[`i']
					global pbpb=pb7_pb6[`i']
				local t1=`t2'+10
						cor207 $t_upb $pbpb
					replace t_u8_pb6_7cor= $t_upbcor in `i'
	  				 }/*del forvalues*/

	  			gen float err_t_u8_pb6_7cor=0 /*los errores de las edades corregidas de Pb comun con 207*/
	 	 		forvalues i=1(1)`ndata' {/*207 correction when no 204 correction has been made*/
	  				global pbpb=pb7_pb6[`i']
	  				global alfa=lo_u8_pb6[`i']/(0.835722-lo_pb7_pb6[`i'])
	  				local hi_upb=hi_u8_pb6[`i']+$alfa*($pbpb-lo_pb7_pb6[`i'])
					global t_upb=(10000/1.55125)*log(1+1/`hi_upb')
					local t1=`t2'+10
					cor207 $t_upb $pbpb
					replace err_t_u8_pb6_7cor= t_u8_pb6_7cor[`i']-$t_upbcor in `i'
					}/*del forvalues*/
				}

		if  "`correction_204'"=="y" { /*207 correction when 204 correction has been also made*/
				capture drop t_u8_pb6_7cor err_t_u8_pb6_7cor
				gen float t_u8_pb6_7cor=0 	/*las edades corregidas de Pb comun con 207*/
				forvalues i=1(1)`ndata' {
					global t_upb=(10000/1.55125)*log(1+pb6_u8_uncor[`i'])
					global pbpb=pb7_pb6_uncor[`i']
					local t1=`t2'+10
					cor207 $t_upb $pbpb
					replace t_u8_pb6_7cor= $t_upbcor in `i'
	  			 	}/*del forvalues*/

	  			gen float err_t_u8_pb6_7cor=0 /*los errores de las edades corregidas de Pb comun con 207*/
	  			quietly {/*los mximos y minimos para las barras de error*/  			
					capture drop hi_pb7_pb6_uncor hi_pb7_pb6_uncor lo_pb7_pb6_uncor hi_u8_pb6_uncor lo_u8_pb6_uncor
					gen hi_pb7_pb6_uncor=pb7_pb6_uncor*(1+err_pb7_pb6/100)
					gen lo_pb7_pb6_uncor=pb7_pb6_uncor*(1-err_pb7_pb6/100)
					gen hi_u8_pb6_uncor=(1/pb6_u8_uncor)*(1+err_pb6_u8/100)
					gen lo_u8_pb6_uncor=(1/pb6_u8_uncor)*(1-err_pb6_u8/100)
						}
						
	 	 		forvalues i=1(1)`ndata' {
	  				global pbpb=pb7_pb6_uncor[`i']
	  				global alfa=lo_u8_pb6_uncor[`i']/(0.835722-lo_pb7_pb6_uncor[`i'])
	  				local hi_upb=hi_u8_pb6_uncor[`i']+$alfa*($pbpb-lo_pb7_pb6_uncor[`i'])
					global t_upb=(10000/1.55125)*log(1+1/`hi_upb')
					local t1=`t2'+10
					cor207 $t_upb $pbpb
					replace err_t_u8_pb6_7cor= t_u8_pb6_7cor[`i']-$t_upbcor in `i'
					}/*del forvalues*/
					capture drop hi_pb7_pb6_uncor hi_pb7_pb6_uncor lo_pb7_pb6_uncor hi_u8_pb6_uncor lo_u8_pb6_uncor
				}/*del if 204_corr*/
	}/*end quietly de las edades*/
	
	/*aqui hago las lista*/

		format %9.1f t_u8_pb6_7cor t_u8_pb6 t_u5_pb7 t_pb7_pb6 t_th_pb8 err_t_u8_pb6 err_t_u8_pb6_7cor err_t_u5_pb7 err_t_pb7_pb6 err_t_th_pb8
			if  "`correction_204'"=="y" display as text"204-corrected ages"
			if  "`correction_204'"~="y" display as text"Common-lead uncorrected ages"
		display as text "        id      207-cor(1s)  206Pb/238U(1s)  207Pb/235U(1s)  207Pb/206Pb(1s)  208Pb/232Th(1s)"  
 		list id t_u8_pb6_7cor err_t_u8_pb6_7cor t_u8_pb6 err_t_u8_pb6 t_u5_pb7 err_t_u5_pb7 t_pb7_pb6 err_t_pb7_pb6 t_th_pb8 err_t_th_pb8 if tipo==1, noheader compress
		
/* input parameters for plot*/
display
display
display as result ". INPUT OF AGE LIMITS FOR CONCORDIA PLOT"
display
local llval "junk"
capture confirm number `llval'
while _rc!=0 {
  	        display as result ". Lower Limit? " _cont
  	        display _request(_llval)
              capture confirm number `llval'
              } 
local hval "junk"
capture confirm number `hval'
while _rc!=0 {
             display as result ". Upper Limit? " _cont
             display _request(_hval)
             capture confirm number `hval'
             } 
local tolab "junk"
capture confirm number `tolab'
while _rc!=0 {
             display as result ". Labels to plot are multiple of? " _cont
             display _request(_interval)
             capture confirm number `interval'
             }             
              
local witherrorbars "junk"             
capture confirm string `witherrorbars'
if _rc!=0 {
             display as result". Shall I plot error bars? (y/n)" _cont
             display _request(_witherrorbars)
             capture confirm string `witherrorbars'
             }


local j=`ndata'
quietly{
	gen t_plot=0
	gen caso=_n
	gen label=0
	local j=_N
	replace tipo=0 if caso>`ndata' /*tipo es 1 si es una muestra, 0 si es auxiliar de proyeccion*/
	forvalues i=`llval'(`interval')`hval' {
          	 local j=`j'+1
          	 set obs `j'
          	 replace caso=`j' in `j'
          	 replace t_plot=`i' in `j'
          	 replace pb6_u8=(exp(t_plot*1.55125/10000)-1) in `j'
          	 replace pb7_u5=(exp(t_plot*9.8485/10000)-1)  in `j'
		 replace id="to_plot" in `j'
		 replace tipo=0 in `j'
		 replace label=1 in `j'
             }
	}/*end quietly*/
	

	
/*calculo de las barras de error*/
	quietly{
	gen hi_pb6_u8=pb6_u8*(1+err_pb6_u8/100)
	gen lo_pb6_u8=pb6_u8*(1-err_pb6_u8/100)
	gen hi_pb7_u5=137.88097*hi_pb6_u8*hi_pb7_pb6
	gen lo_pb7_u5=137.88097*lo_pb6_u8*lo_pb7_pb6
	
	local llval_ycoor=(exp(`llval'*1.55125/10000)-1)
	local llval_xcoor=(exp(`llval'*9.8485/10000)-1)
	local hval_ycoor=(exp(`hval'*1.55125/10000)-1)
	local hval_xcoor=(exp(`hval'*9.8485/10000)-1)
	
		/*calculo de los mximos y mnimos del diagrama*/
		sum lo_pb6_u8 if es==1
		local ymin=r(min)
		if `ymin'>`llval_ycoor'{
			local ymin=`llval_ycoor'
			}
		sum hi_pb6_u8 if es==1
		local ymax=r(max)
		if `ymax'<`hval_ycoor'{
			local ymax=`hval_ycoor'
			}
		sum lo_pb7_u5 if es==1
		local xmin=r(min)
		if `xmin'>`llval_xcoor'{
			local xmin=`llval_xcoor'
			}
		sum hi_pb7_u5 if es==1
		local xmax=r(max)
		if `xmax'<`hval_xcoor'{
			local xmax=`hval_xcoor'
			}
			
	/*calculo de coordenadas y*/

		local cont_ymax= `ymax'
		local f1=1
		while round(`cont_ymax')==0{
			local f1=`f1'*10
			local cont_ymax=`ymax'*`f1'
			}/*del while*/
		local ymax= ceil(`cont_ymax'*10)/(`f1'*10)
		local ymin= floor(`ymin'*`f1'*10)/(`f1'*10)
		local yinterval1=ceil(((`ymax'-`ymin')/5)*`f1'*100)/(`f1'*100)
		local yinterval2=ceil(((`ymax'-`ymin')/4)*`f1'*100)/(`f1'*100)
		local yinterval3=ceil(((`ymax'-`ymin')/3)*`f1'*100)/(`f1'*100)
		local cont_yinterval1=`yinterval1'*5
		local cont_yinterval2=`yinterval2'*4
		local cont_yinterval3=`yinterval1'*3
		if `cont_yinterval1' >= `cont_yinterval2' {
				local yinterval=`yinterval2'
				local cont_yinterval=`cont_yinterval2'
				local yk=4
					}
			else{
				local yinterval=`yinterval1'
					local cont_yinterval=`cont_yinterval1'
					local yk=5
					}
		if `cont_yinterval' >= `cont_yinterval3'{
				local yinterval=`yinterval3'
				local cont_yinterval=`cont_yinterval3'
				local yk=3
					}
			local ymax=`ymin'+`yinterval'*`yk'
	/*hasta aqui coordenadas y*/
	
	/*calculo de coordenadas x*/
	
	if $change_coord==1{/*vario a mano las coordenadas*/
			local ymin=$ymin
			local yinterval=$yinterval
			local ymax=$ymax
			local xmin=$xmin
			local xinterval=$xinterval
			local xmax=$xmax
			} /*fin de vario a mano las coordenadas*/
			else
			{
	
				local cont_xmax= `xmax'
				local f1=1
				while round(`cont_xmax')==0{
					local f1=`f1'*10
					local cont_xmax=`xmax'*`f1'
					}/*del while*/
				local xmax= ceil(`cont_xmax'*10)/(`f1'*10)
				local xmin= floor(`xmin'*`f1'*10)/(`f1'*10)
				local xinterval1=ceil(((`xmax'-`xmin')/5)*`f1'*10)/(`f1'*10)
				local xinterval2=ceil(((`xmax'-`xmin')/4)*`f1'*10)/(`f1'*10)
				local xinterval3=ceil(((`xmax'-`xmin')/3)*`f1'*10)/(`f1'*10)
				local cont_xinterval1=`xinterval1'*5
				local cont_xinterval2=`xinterval2'*4
				local cont_xinterval3=`xinterval1'*3
				if `cont_xinterval1' >= `cont_xinterval2' {
				local xinterval=`xinterval2'
				local cont_xinterval=`cont_xinterval2'
				local xk=4
					}
			else{
				local xinterval=`xinterval1'
					local cont_xinterval=`cont_xinterval1'
					local xk=5
					}
		if `cont_xinterval'>= `cont_xinterval3'{
				local xinterval=`xinterval3'
				local cont_xinterval=`cont_xinterval3'
				local xk=3
					}
			local xmax=`xmin'+`xinterval'*`xk'
		}/*del else*/	
			
		
local factor_coor=`aspect_ratio'*(`xmax'-`xmin')/(`ymax'-`ymin')

/*calculo la pendiente y las coordenadas de las barras inclinadas*/	
	gen alfa=atan(pb6_u8-lo_pb6_u8)*`factor_coor'/(pb7_u5-lo_pb7_u5)
	gen lo_a=pb7_u5+(pb6_u8-lo_pb6_u8)*sin(alfa)*cos(alfa)*`factor_coor'
	gen lo_b=lo_pb6_u8+(pb6_u8-lo_pb6_u8)*sin(alfa)*sin(alfa)
	gen hi_a=pb7_u5-(pb6_u8-lo_pb6_u8)*sin(alfa)*cos(alfa)*`factor_coor'
	gen hi_b=hi_pb6_u8-(pb6_u8-lo_pb6_u8)*sin(alfa)*sin(alfa) 


	}/*end quietly*/
	
/* dos opciones de dibujar, con o sin error bars*/

if "`witherrorbars'" =="y" {
twoway (line pb6_u8 pb7_u5 if tipo==0, lcolor(blue)) (scatter pb6_u8 pb7_u5 if tipo==0 & label==1, mcolor(blue) msymbol(square) msize(small) mlabel(t_plot) mlabposition(10)) (pcspike lo_pb6_u8 lo_pb7_u5 hi_pb6_u8 hi_pb7_u5 if tipo==1 & es ==1, lcolor(gs10) lwidth(thin))  (scatter pb6_u8 pb7_u5 if tipo==1 & es ==1, mcolor(red) msymbol(circle) msize(small)), ytitle("206Pb/238U") ylabel(`ymin'(`yinterval')`ymax', labsize(small) angle(horizontal) format(%9.3f)) ymtick(##5, nolabels) xtitle(207Pb/235U) xlabel(`xmin'(`xinterval')`xmax', labsize(small) format(%9.3f)) xmtick(##5, nolabels) aspectratio(`aspect_ratio') title(`graph_title') legend(off) plotregion(lcolor(black))
}
else {
twoway (line pb6_u8 pb7_u5 if tipo==0, lcolor(blue)) (scatter pb6_u8 pb7_u5 if tipo==0 & label==1, mcolor(blue) msymbol(square) msize(small) mlabel(t_plot) mlabposition(10)) (scatter pb6_u8 pb7_u5 if tipo==1 & es ==1, mcolor(red) msymbol(circle)), ytitle("206Pb/238U") ylabel(, labsize(small) angle(horizontal) format(%9.3f)) ymtick(##5, nolabels) xtitle(207Pb/235U)  xlabel(, labsize(small) format(%9.3f)) xmtick(##5, nolabels) aspectratio(`aspect_ratio') title(`graph_title') legend(off) plotregion(lcolor(black))
}
	quietly graph rename Wetherill1, replace

/*redibujar con coordenadas manuales*/
display
display

display as result ". DO YOU WANT TO CHANGE MANUALLY THE COORDINATES?"
	local manual "junk"
	capture confirm string `manual'
	if !_rc == 0 {
             display as result "  y / n? " _cont
			 display _request(_manual)
             capture confirm string `manual'
             } 
    		
if "`manual'"=="y"{

  display as result ". Input new coordinates"
 		  
 			local ymin "junk"
			capture confirm number `ymin'
			while _rc!=0 { /* 1*/
  	        	display as result ". Lower Y Limit? " _cont
  	        	display _request(_ymin)
              	capture confirm number `ymin'
             	 } /*del while 1*/            
			
			local ymax "junk"
			capture confirm number `ymax'
			while _rc!=0 { /* 2*/
  	        	display as result ". Upper Y Limit? " _cont
  	        	display _request(_ymax)
              	capture confirm number `ymax'
             	 } /*del while 2*/            
			
			local yinterval "junk"
			capture confirm number `yinterval'
			while _rc!=0 { /* 3*/
  	        	display as result ". Y interval? " _cont
  	        	display _request(_yinterval)
              	capture confirm number `yinterval'
             	 } /*del while 3*/            
			display
			local xmin "junk"
			capture confirm number `xmin'
			while _rc!=0 { /* 4*/
  	        	display as result ". Lower X Limit? " _cont
  	        	display _request(_xmin)
              	capture confirm number `xmin'
             	 } /*del while 4*/            
			
			local xmax "junk"
			capture confirm number `xmax'
			while _rc!=0 { /* 5*/
  	        	display as result ". Upper X Limit? " _cont
  	        	display _request(_xmax)
              	capture confirm number `xmax'
             	 } /*del while 5*/            
			
			local xinterval "junk"
			capture confirm number `xinterval'
			while _rc!=0 { /* 6*/
  	        	display as result ". X interval? " _cont
  	        	display _request(_xinterval)
              	capture confirm number `xinterval'
             	 } /*del while 6*/            

           quietly{
           local factor_coor=`aspect_ratio'*(`xmax'-`xmin')/(`ymax'-`ymin')

				/*calculo la pendiente y las coordenadas de las barras inclinadas*/	
					replace alfa=atan(pb6_u8-lo_pb6_u8)*`factor_coor'/(pb7_u5-lo_pb7_u5)
					replace lo_a=pb7_u5+(pb6_u8-lo_pb6_u8)*sin(alfa)*cos(alfa)/`factor_coor'
					replace lo_b=lo_pb6_u8+(pb6_u8-lo_pb6_u8)*sin(alfa)*sin(alfa)
					replace hi_a=pb7_u5-(pb6_u8-lo_pb6_u8)*sin(alfa)*cos(alfa)/`factor_coor'
					replace hi_b=hi_pb6_u8-(pb6_u8-lo_pb6_u8)*sin(alfa)*sin(alfa) 

				}/*end quietly*/

	
			/* dos opciones de dibujar, con o sin error bars*/

			if "`witherrorbars'" =="y" {
if "`witherrorbars'" =="y" {
twoway (line pb6_u8 pb7_u5 if tipo==0, lcolor(blue)) (scatter pb6_u8 pb7_u5 if tipo==0 & label==1, mcolor(blue) msymbol(square) msize(small) mlabel(t_plot) mlabposition(10)) (pcspike lo_pb6_u8 lo_pb7_u5 hi_pb6_u8 hi_pb7_u5 if tipo==1 & es ==1, lcolor(gs10) lwidth(thin)) (pcspike hi_b hi_a lo_b lo_a if tipo==1 & es ==1, lcolor(gs10) lwidth(thin)) (scatter pb6_u8 pb7_u5 if tipo==1 & es ==1, mcolor(red) msymbol(circle) msize(small)), ytitle("206Pb/238U") ylabel(`ymin'(`yinterval')`ymax', labsize(small) angle(horizontal) format(%9.3f)) ymtick(##5, nolabels) xtitle(207Pb/235U) xlabel(`xmin'(`xinterval')`xmax', labsize(small) format(%9.3f)) xmtick(##5, nolabels) aspectratio(`aspect_ratio') title(`graph_title') legend(off) plotregion(lcolor(black))
}
else {
twoway (line pb6_u8 pb7_u5 if tipo==0, lcolor(blue)) (scatter pb6_u8 pb7_u5 if tipo==0 & label==1, mcolor(blue) msymbol(square) msize(small) mlabel(t_plot) mlabposition(10)) (scatter pb6_u8 pb7_u5 if tipo==1 & es ==1, mcolor(red) msymbol(circle)), ytitle("206Pb/238U") ylabel(, labsize(small) angle(horizontal) format(%9.3f)) ymtick(##5, nolabels) xtitle(207Pb/235U)  xlabel(, labsize(small) format(%9.3f)) xmtick(##5, nolabels) aspectratio(`aspect_ratio') title(`graph_title') legend(off) plotregion(lcolor(black))
}

			quietly graph rename Wetherill1b, replace
	
}/*end if manual*/	
	
	
	
	
/*rutina para concordia*/	
	display
	display
display as result ". DO YOU WANT A DISCORDIA LINE AND INTERCEPTION?"
	local hago_dis "junk"
	capture confirm string `hago_dis'
	if !_rc == 0 {
             display as result "  y / n? " _cont
			 display _request(_hago_dis)
             capture confirm string `hago_dis'
             } 
    	
/*rutina para intercepciones*/
	if "`hago_dis'" == "y" {
	quietly{
		sum pb7_u5 if es==1
		local xmean=r(mean)
		sum pb6_u8 if es==1
		local ymean=r(mean) /* hasta aqui calculo las medias de los puntos representados*/
		/* ecuacin de la concordia; calculo las intercepciones*/
	
		reg pb6_u8 pb7_u5 if es==1
		local b=_b[pb7_u5]
		local cte= _b[_cons]
		
		/*mswd*/
		capture drop resid error_in_y
		predict double resid if es==1, residuals
		replace resid=resid^2
		sum resid if es==1
		local mswd_num=r(sum)
		if  "`correction_204'"=="y" {
			gen error_in_y=pb6_u8_4cor*err_pb6_u8/100 if es==1
			}
			else{
			gen error_in_y=pb6_u8*err_pb6_u8/100 if es==1
			}
		replace error_in_y=error_in_y^2
		sum error_in_y
		local mswd_den=r(sum)
		local mswd=(`mswd_num'/`mswd_den')/(r(N)-2)
		drop resid error_in_y
		/*end mswd*/
		
		/* intercepcion superior*/	
		local control=1
		local x= `xmean'
		while `control' > 0{
			local x=`x' + 0.1
			local y=`b'*`x'+`cte'
			local age_y= (10000/1.55125)*log(1+`y')
			local age_x= (10000/9.8485)*log(1+`x')
			if `age_y'>=`age_x' local control=0
			}
		local control=1
		local x= `x'-0.1
		  while `control' > 0{
		  	local x=`x' + 0.01
			local y=`b'*`x'+`cte'
			local age_y= (10000/1.55125)*log(1+`y')
			local age_x= (10000/9.8485)*log(1+`x')
			if `age_y'>=`age_x' local control=0
			}
		local control=1
		local x= `x'-0.01
		  while `control' > 0{
		  	local x=`x' + 0.001
			local y=`b'*`x'+`cte'
			local age_y= (10000/1.55125)*log(1+`y')
			local age_x= (10000/9.8485)*log(1+`x')
			if `age_y'>=`age_x' local control=0
			}
			local xmaxd=`x'
			local ymaxd= `y'
			local upper=`age_y'
			
		/* intercepcion inferior*/
		local control=1
		local x= `xmean'
		while `control' > 0{
			local x=`x' - 0.1
			local y=`b'*`x'+`cte'
			local age_low_y= (10000/1.55125)*log(1+`y')
			local age_x= (10000/9.8485)*log(1+`x')
			if `age_low_y'>=`age_x' local control=0
			}
		local control=1
		local x= `x'+0.1
		  while `control' > 0{
		  	local x=`x' - 0.01
			local y=`b'*`x'+`cte'
			local age_low_y= (10000/1.55125)*log(1+`y')
			local age_x= (10000/9.8485)*log(1+`x')
			if `age_low_y'>=`age_x' local control=0
			}
		local control=1
		local x= `x'+0.01
		  while `control' > 0{
		  	local x=`x' - 0.001
			local y=`b'*`x'+`cte'
			local age_low_y= (10000/1.55125)*log(1+`y')
			local age_x= (10000/9.8485)*log(1+`x')
			if `age_low_y'>=`age_x' local control=0
			}
			local xmind=`x'
			if `xmind'<0 local xmind=0
			local ymind= `y'
			if `ymind'<0 local ymind=0
			local lower=`age_low_y'
			
		/*calculo los errores en las intercepciones y en la media*/
		local nobs=_N
		local i = _N+3
		set obs `i'
		local i=`nobs'+1
		replace pb7_u5=`xmind' in `i'
		replace pb6_u8=`ymind' in `i'
		replace id= "junk" in `i'
		local i=`nobs'+2
		replace pb7_u5=`xmean' in `i'
		replace pb6_u8=`ymean' in `i'
		replace id= "junk" in `i'
		local i=`nobs'+3
		replace pb7_u5=`xmaxd' in `i'
		replace pb6_u8=`ymaxd' in `i'
		replace id= "junk" in `i'
		predict err_i, stdp /*err_i es el intervalo de confidencia*/
		
		gen y2= pb6_u8-2*err_i
		gen y3= pb6_u8+2*err_i
		 /* y2 de y3 son las coordenadas de los errores en intercepciones*/
		gen ello=.
		local i=`nobs' + 2
		replace ello=1 in `i'
		
	/*calulo de errores upper*/
		
		local i=`nobs' + 3
		replace ello=1 in `i' 			
			/*minimo superior*/
			reg y3 pb7_u5 if ello==1
			local b=_b[pb7_u5]
			local cte= _b[_cons]
			local control=1
			local x= `xmean'
			while `control' > 0{
				local x=`x' + 0.1
				local y=`b'*`x'+`cte'
				local age_y= (10000/1.55125)*log(1+`y')
				local age_x= (10000/9.8485)*log(1+`x')
				if `age_y'>=`age_x' local control=0
				}
			local control=1
			local x= `x'-0.1
			  while `control' > 0{
			  	local x=`x' + 0.01
				local y=`b'*`x'+`cte'
				local age_y= (10000/1.55125)*log(1+`y')
				local age_x= (10000/9.8485)*log(1+`x')
				if `age_y'>=`age_x' local control=0
				}
			local control=1
			local x= `x'-0.01
			 	while `control' > 0{
			 	local x=`x' + 0.001
				local y=`b'*`x'+`cte'
				local age_y= (10000/1.55125)*log(1+`y')
				local age_x= (10000/9.8485)*log(1+`x')
				if `age_y'>=`age_x' local control=0
				}
			local err_u_1=`upper'-`age_y'
	
		
			/*maximo superior*/
			reg y2 pb7_u5 if ello==1
			local b=_b[pb7_u5]
			local cte= _b[_cons]
			local control=1
			local x= `xmean'
			while `control' > 0{
				local x=`x' + 0.1
				local y=`b'*`x'+`cte'
				local age_y= (10000/1.55125)*log(1+`y')
				local age_x= (10000/9.8485)*log(1+`x')
				if `age_y'>=`age_x' local control=0
				}
			local control=1
			local x= `x'-0.1
			  while `control' > 0{
			  	local x=`x' + 0.01
				local y=`b'*`x'+`cte'
				local age_y= (10000/1.55125)*log(1+`y')
				local age_x= (10000/9.8485)*log(1+`x')
				if `age_y'>=`age_x' local control=0
				}
			local control=1
			local x= `x'-0.01
			 	while `control' > 0{
			 	local x=`x' + 0.001
				local y=`b'*`x'+`cte'
				local age_y= (10000/1.55125)*log(1+`y')
				local age_x= (10000/9.8485)*log(1+`x')
				if `age_y'>=`age_x' local control=0
				}
			local err_u_2=`age_y'-`upper'

	/*calulo de errores lower*/
		
		local i=`nobs' + 3
		replace ello=. in `i'
		local i=`nobs' + 1
		replace ello=1 in `i'			
		/*maximo inferior*/
			reg y3 pb7_u5 if ello==1
			local b=_b[pb7_u5]
			local cte= _b[_cons]
			local control=1
			local x= `xmean'
			while `control' > 0{
				local x=`x' - 0.1
				local y=`b'*`x'+`cte'
				local age_y= (10000/1.55125)*log(1+`y')
				local age_x= (10000/9.8485)*log(1+`x')
				if `age_y'>=`age_x' local control=0
				}
			local control=1
			local x= `x'+0.1
			  while `control' > 0{
			  	local x=`x' - 0.01
				local y=`b'*`x'+`cte'
				local age_y= (10000/1.55125)*log(1+`y')
				local age_x= (10000/9.8485)*log(1+`x')
				if `age_y'>=`age_x' local control=0
				}
			local control=1
			local x= `x'+0.01
			 	while `control' > 0{
			 	local x=`x' - 0.001
				local y=`b'*`x'+`cte'
				local age_y= (10000/1.55125)*log(1+`y')
				local age_x= (10000/9.8485)*log(1+`x')
				if `age_y'>=`age_x' local control=0
				}
			local err_l_1=`age_y'-`lower'
			
			/*minimo inferior*/
			reg y2 pb7_u5 if ello==1
			local b=_b[pb7_u5]
			local cte= _b[_cons]
			local control=1
			local x= `xmean'
			while `control' > 0{
				local x=`x' - 0.1
				local y=`b'*`x'+`cte'
				local age_y= (10000/1.55125)*log(1+`y')
				local age_x= (10000/9.8485)*log(1+`x')
				if `age_y'>=`age_x' local control=0
				}
			local control=1
			local x= `x'+0.1
			  while `control' > 0{
			  	local x=`x' - 0.01
				local y=`b'*`x'+`cte'
				local age_y= (10000/1.55125)*log(1+`y')
				local age_x= (10000/9.8485)*log(1+`x')
				if `age_y'>=`age_x' local control=0
				}
			local control=1
			local x= `x'+0.01
			 	while `control' > 0{
			 	local x=`x' - 0.001
				local y=`b'*`x'+`cte'
				local age_y= (10000/1.55125)*log(1+`y')
				local age_x= (10000/9.8485)*log(1+`x')
				if `age_y'>=`age_x' local control=0
				}
			local err_l_2=`lower'-`age_y'
			
		local ue1=string(`err_u_2', "%9.1f")
		local ue2=string(`err_u_1', "%9.1f")
	
		
		local le1=string(`err_l_1', "%9.1f")
		if `err_l_2'>`lower' {
			local err_l_2 =`lower'
			}
		local le2=string(`err_l_2', "%9.1f")
		drop err_i y2 y3 ello
		drop if id=="junk"
		}/*del quietly]*/
		display as result ". UPPER INTERCEPT = " %9.1f  `upper' " +" `ue1' " -" `ue2' " Ma"
		display as result ". LOWER INTERCEPT = " %9.1f  `lower' " +" `le1' " -" `le2' " Ma"
		display as result ". MSWD = " %9.4f  `mswd'
		if `xmaxd' > `xmax' local xmaxd=`xmax'
		if `xmind' < `xmin' local xmind=`xmin'
		if "`witherrorbars'" =="y" {
		twoway (lfitci pb6_u8 pb7_u5 if tipo==1 & es == 1, range(`xmind' `xmaxd') fcolor(bluishgray) blcolor(ltbluishgray)) (line pb6_u8 pb7_u5 if tipo==0, lcolor(blue)) (scatter pb6_u8 pb7_u5 if tipo==0 & label==1, mcolor(blue) msymbol(square) msize(small) mlabel(t_plot) mlabposition(10)) (pcspike lo_pb6_u8 lo_pb7_u5 hi_pb6_u8 hi_pb7_u5 if tipo==1 & es ==1, lcolor(gs10) lwidth(thin)) (pcspike hi_b hi_a lo_b lo_a if tipo==1 & es ==1, lcolor(gs10) lwidth(thin)) (scatter pb6_u8 pb7_u5 if tipo==1 & es ==1, mcolor(red) msymbol(circle) msize(small)), ytitle("206Pb/238U") ylabel(`ymin'(`yinterval')`ymax', labsize(small) angle(horizontal) format(%9.3f)) ymtick(##5, nolabels) xtitle(207Pb/235U) xlabel(`xmin'(`xinterval')`xmax', labsize(small) format(%9.3f)) xmtick(##5, nolabels) aspectratio(`aspect_ratio') title(`graph_title') legend(off) plotregion(lcolor(black))
		}
		else {
		twoway (lfitci pb6_u8 pb7_u5 if tipo==1 & es == 1, range(`xmind' `xmaxd') fcolor(bluishgray) blcolor(ltbluishgray))(line pb6_u8 pb7_u5 if tipo==0, lcolor(blue)) (scatter pb6_u8 pb7_u5 if tipo==0 & label==1, mcolor(blue) msymbol(square) msize(small) mlabel(t_plot) mlabposition(10)) (scatter pb6_u8 pb7_u5 if tipo==1 & es ==1, mcolor(red) msymbol(circle)), ytitle("206Pb/238U") yscale(range(`ymind' `ymax')) ylabel(#5, labsize(small) angle(horizontal) format(%9.3f)) ymtick(##5, nolabels) xtitle(207Pb/235U) xscale(range(`xmin' `xmax')) xlabel(, labsize(small) format(%9.3f)) xmtick(##5, nolabels) aspectratio(`aspect_ratio') title(`graph_title') legend(off) plotregion(lcolor(black))
		}
		quietly graph rename Wetherill2, replace
	}/*rutina para intercepciones*/

	quietly{
		drop if id=="to_plot"
		capture drop caso t_plot label
		drop hi_pb6_u8 lo_pb6_u8 hi_pb7_u5 lo_pb7_u5 alfa lo_a lo_b hi_a hi_b hi_b
		drop hi_pb7_pb6 lo_pb7_pb6 hi_u8_pb6 lo_u8_pb6
		if  "`correction_204'"=="y"{
			replace pb7_pb6=pb7_pb6_uncor
			replace pb6_u8=pb6_u8_uncor
			replace pb8_th=pb8_th_uncor
			drop pb7_pb6_uncor pb6_u8_uncor pb8_th_uncor 
			}
		}/*del quietly*/
display
display as text ". Done Concordia"
end /*del ado*/

				
capture program define sk 
		args p207 p208 p204

		local sk7=15.628-(9.735/137.88)*(exp(9.84850*10^(-4)*$t_pbpb)-1)
		local sk6=18.7-9.735*(exp(1.55125*10^(-4)*$t_pbpb)-1)
		local sk8=38.63-(36.837)*(exp(4.9475*10^(-5)*$t_pbpb)-1)
		local cden=1/`p204'-`sk6' 
		local cnum=`p207'*(1/`p204')-`sk7' 
		global pb207_4cor=`cnum'/`cden'	
		if $pb207_4cor<0 global pb207_4cor=0 
		global pb6_u8_4cor=`cden'*`p204'*pb6_u8[$i]
		local cnum2=`p208'*(1/`p204')-`sk8' 
		global pb208_4cor=`cnum2'/`cden'
		global pb8_th_4cor=`cnum2'*pb8_th[$i]/(`p208'*(1/`p204'))
		if pb4_pb6[$i] <= 0 | pb4_pb6[$i] ==.{	
			global pb207_4cor=pb7_pb6[$i]
			global pb208_4cor=pb8_pb6[$i]
			global pb6_u8_4cor=pb6_u8[$i]
			global pb8_th_4cor=pb8_th[$i]
			}
end

capture program define t_pbpb
	args pbpb

	local t1=-99
		local t2=0
		local control=1
		while `control' > 0 {
			local t1=`t1' + 100 
			local pb7_pb6_0=(0.72*(exp(`t1'*9.8485/10000)-1))/(99.2743*(exp(`t1'*1.55125/10000)-1))			
			if `pb7_pb6_0' >= `pbpb' local control=0
			}
		local t2=`t1'- 100
		local t1=`t2'
		local control=1
		while `control' > 0 {
			local t1=`t1' + 10 
			local pb7_pb6_0=(0.72*(exp(`t1'*9.8485/10000)-1))/(99.2743*(exp(`t1'*1.55125/10000)-1))
			if `pb7_pb6_0' >=  `pbpb' local control=0
			}
		local t2=`t1'- 10
		local t1=`t2'
		local control=1
		while `control' > 0 {
			local t1=`t1' + 1 
			local pb7_pb6_0=(0.72*(exp(`t1'*9.8485/10000)-1))/(99.2743*(exp(`t1'*1.55125/10000)-1))
			if `pb7_pb6_0' >=  `pbpb' local control=0
			}
		local t2=`t1'- 1
		local t1=`t2'
		local control=1
		while `control' > 0 {
			local t1=`t1' + 0.2 
			local pb7_pb6_0=(0.72*(exp(`t1'*9.8485/10000)-1))/(99.2743*(exp(`t1'*1.55125/10000)-1))
			if `pb7_pb6_0' >=  `pbpb' local control=0
			}
		local t2=`t1'- 0.2

		global t_pbpb = (`t1'+`t2')/2
	end /*del t_pbpb*/	


capture program define cor207 	/*rutina para corregir la edad 238U/206Pb de Pb comun, por proyeccin en Tera-Wasserburg*/
	args t_upb pbpb
	local t2=`t_upb'
		local t1=`t2'+10
		local upb_c=1/(exp(`t2'*1.55125/10000)-1)
		local b= 0.835722 /*la ecuacion de la recta desde Pb comun a muestra*/
		local a=(`pbpb'-`b')/`upb_c'
		local control=1
		while `control' > 0 {
			local t1=`t1'-10 
			local pb7_pb6_c=(0.72*(exp(`t1'*9.8485/10000)-1))/(99.2743*(exp(`t1'*1.55125/10000)-1))
			local upb_c=1/(exp(`t1'*1.55125/10000)-1)
			local pb7_pb6_r=`upb_c'*`a'+`b'
			if `pb7_pb6_c' > `pb7_pb6_r' local control=0
			}
			local t2=`t1'+ 10
			local t1=`t2'
			local control=1	
		while `control' > 0 {
			local t1=`t1'-1
			local pb7_pb6_c=(0.72*(exp(`t1'*9.8485/10000)-1))/(99.2743*(exp(`t1'*1.55125/10000)-1))
			local upb_c=1/(exp(`t1'*1.55125/10000)-1)
			local pb7_pb6_r=`upb_c'*`a'+`b'
			if `pb7_pb6_c' > `pb7_pb6_r' local control=0
			}
  			local t2=`t1'+1
  			local t1=`t2'
			local control=1		
		while `control' > 0 {
			local t1=`t1'-0.1
			local pb7_pb6_c=(0.72*(exp(`t1'*9.8485/10000)-1))/(99.2743*(exp(`t1'*1.55125/10000)-1))
			local upb_c=1/(exp(`t1'*1.55125/10000)-1)
			local pb7_pb6_r=`upb_c'*`a'+`b'
			if `pb7_pb6_c' > `pb7_pb6_r' local control=0
			}
  			local t2=`t1'+0.05
		    global t_upbcor= `t2'
		   end/*del t_upb*/ 
		
