program define iso_nd
	version 10

	display
	display
	display
	display as text ". Nd PARAMETERS - ISOTOOLS by F. Bea (2007); v. 2.0"
	display
	display
	display as text ". THIS ROUTINE NEEDS THE VARIABLES NAMED" as error" nd, sm, ndnd, age (IN MILLION YEARS)"
	display 
	display
	capture confirm numeric variable sm
	if _rc~=0 {
	des
	display ". YOU DO NOT HAVE A NUMERIC VARIABLE NAMED sm, I.E. THE PPM OF Sm"
	exit
	}
	capture confirm numeric variable nd 
	if _rc~=0 {
	des
	display ". YOU DO NOT HAVE A NUMERIC VARIABLE NAMED nd, I.E. THE PPM OF Nd"
	exit
	}
	capture confirm numeric variable ndnd 
	if _rc~=0 {
	des
	display ". YOU DO NOT HAVE A NUMERIC VARIABLE NAMED ndnd, I.E. THE 143Nd/144Sr RATIO  "
	exit
	}
	capture confirm numeric variable age
	if _rc~=0 {
	des
	display ". YOU DO NOT HAVE A NUMERIC VARIABLE NAMED age, I.E. THE AGE IN MILLION YEARS  "
	exit
	}
	quietly{
		capture drop smnd 
		capture drop ndnd_t 
		capture drop eps_nd_t 
		capture drop ndmodage 
		capture drop ndmodagedep
		label var ndnd "143Nd/144Nd"
		label var age Ma
		label var sm Sm
		label var nd Nd
		gen float smnd=sm*0.60459938/nd
		label var smnd "147Sm/144Nd"
		gen float ndnd_t=ndnd-smnd*((exp(0.00000653974*age))-1)
		label var ndnd_t "143Nd/144Nd_t"
		gen float eps_nd_t=((ndnd_t/(0.512638-0.1967*(exp(0.00000654*age)-1)))-1)*10000
		label var eps_nd_t "epsilon_t Nd"
		gen float ndmodage=(1/(6.53974*10^-6))*log(1+(ndnd-0.512638)/(smnd-0.1967))
		label var ndmodage "Nd model age"
		gen ndmodagedep=(1/(6.53974*10^-6))*log(1+(ndnd-0.513155)/(smnd-0.21378))
		label var ndmodagedep "Nd dep model age"
	}/*del quietly*/
	display as result "Results"
	list id age ndnd_t eps_nd_t ndmodage ndmodagedep
	display
	display as text ". Done Nd isotopes calculations"
	display
end
