program define iso_pbpb
version 10
	capture matrix drop _all
	capture drop cor_207_206
	capture drop cor_204_206
	capture drop cor_208_206
	capture drop age
	capture drop age_error
	display
	display
	display
	display as text". ISOTOOLS by F. Bea (2007); v. 2.0"
	display
	display as text ". Batch Pb-Pb Age Calculations"
	display
	display as text". NEEDS THE VARIABLES:"as error" id, pb207_206, err207_206, pb204_206, err204_206, pb208_206, frac"
	display
	display
	quietly {
			gen age=.
			gen age_error=.
			}
	capture confirm string variable id
	if _rc~=0 {
	display as error". YOU DO NOT HAVE A STRING VARIABLE NAMED -id-"
	exit
	}
	capture confirm numeric variable pb207_206
	if _rc~=0 {
	display as error". YOU DO NOT HAVE A NUMERIC VARIABLE NAMED pb207_206"
	exit
	}
	capture confirm numeric variable pb204_206
	if _rc~=0 {
	display as error". YOU DO NOT HAVE A NUMERIC VARIABLE NAMED pb204_206"
	exit
	}
	capture confirm numeric variable pb208_206
	if _rc~=0 {
	display as error ". YOU DO NOT HAVE A NUMERIC VARIABLE NAMED pb208_206"
	exit
	}
	capture confirm numeric variable err207_206
	if _rc~=0 {
	display as error". YOU DO NOT HAVE A NUMERIC VARIABLE NAMED err207_206"
	exit
	}
	capture confirm numeric variable err204_206
	if _rc~=0 {
	display as error". YOU DO NOT HAVE A NUMERIC VARIABLE NAMED err204_206"
	exit
	}
	capture confirm numeric variable frac
	if _rc~=0 {
	display as error". YOU DO NOT HAVE A CONTROL VARIABLE NAMED frac. 1 CORRECTS FOR FRACTIONATION, 0 DOES NOT"
	exit
	}
	
quietly{
	gen cor_207_206=pb207_206
	gen cor_204_206=pb204_206
	gen cor_208_206=pb208_206
	}
	

/*correct for fractionation*/

	quietly{
		replace cor_207_206 = pb207_206*sqrt(207/206) if frac==1
		replace cor_204_206=pb204_206*sqrt(204/206) if frac==1
		replace cor_208_206=pb208_206*sqrt(208/206) if frac==1
		}/*del quietly*/	
		
global age 0
global i 0
global pb208 0
global pb204 0

while $i<[_N] {/*while 1*/
		global i=$i +1
		global pb207=cor_207_206[$i]
		global pb208=cor_208_206[$i]
		global pb204=cor_204_206[$i]
		global res207=cor_207_206[$i]
		global res204=cor_204_206[$i]
		global age=0		
		age_calc $pb207
		local control $age*2
		
		while int($age*10) !=int(`control'*10) {/*while2*/
			local control=$age
			sk	$pb207 $pb208 $pb204	
			age_calc $pb207_cor
			}/*del while 2*/
		quietly {
		replace cor_207_206= $pb207_cor if [_n]== $i
		replace cor_208_206= $pb208 if [_n]== $i
		replace age=int($age*10)/10 if [_n]== $i
		
		}/*del quietly*/
		local error207 0
		local error204 0
		/*error in 207*/
		global pb207=cor_207_206[$i]*(1+(err207_206[$i]/100))
		age_calc $pb207
			local ageplus $age
			local error207=`ageplus'-age[$i]
		global pb207=cor_207_206[$i]
		global pb204=$res204*(1-(err204_206[$i]/100))
		sk $res207 $pb208 $pb204
		age_calc $pb207
				local ageplus $age
				local error204=abs(`ageplus'-age[$i])
		quietly{
		replace age_error=int((`error207'+`error204')*10)/10 if [_n]==$i
		}
 }/*del while 1*/
 label var id "Zircon ID"
 label var cor_207_206 "cor. 207/206"
 label var err207_206 " (2s %)"
 label var cor_208_206 "cor. 208/206"
 label var age "Age (Ma)"
 label var age_error " Ma"
 tabdisp id,cell(cor_207_206 err207_206 cor_208_206 age age_error)
 display
 display as text ": Done batch Pb-Pb calculations"
 
end	

capture program define age_calc 
			args p207
			local ratio 0
			local t=0
			local increment=100
			while `ratio'<`p207'{
			local t=`t'+`increment'
			local ratio (exp(9.84850*10^(-4)*`t')-1)/(137.88*(exp(1.55125*10^(-4)*`t')-1))
			}
			local t=`t'-`increment'
			local ratio (exp(9.84850*10^(-4)*`t')-1)/(137.88*(exp(1.55125*10^(-4)*`t')-1))
			local increment=10
			while `ratio'<`p207'{
			local t=`t'+`increment'
			local ratio (exp(9.84850*10^(-4)*`t')-1)/(137.88*(exp(1.55125*10^(-4)*`t')-1))
			}
			local t=`t'-`increment'
			local ratio (exp(9.84850*10^(-4)*`t')-1)/(137.88*(exp(1.55125*10^(-4)*`t')-1))
			local increment=1
			while `ratio'<`p207'{
			local t=`t'+`increment'
			local ratio (exp(9.84850*10^(-4)*`t')-1)/(137.88*(exp(1.55125*10^(-4)*`t')-1))
			}
			local t=`t'-`increment'
			local ratio (exp(9.84850*10^(-4)*`t')-1)/(137.88*(exp(1.55125*10^(-4)*`t')-1))
			local increment=0.1
			while `ratio'<`p207'{
			local t=`t'+`increment'
			local ratio (exp(9.84850*10^(-4)*`t')-1)/(137.88*(exp(1.55125*10^(-4)*`t')-1))
			}
			global age= (2*`t'-`increment')/2
end				
				
capture program define sk 
			args p207 p208 p204
			local sk7=15.628-(9.735/137.88)*(exp(9.84850*10^(-4)*$age)-1)
		local sk6=18.7-9.735*(exp(1.55125*10^(-4)*$age)-1)
		local sk8=38.63-(36.837)*(exp(4.9475*10^(-5)*$age)-1)
		local cden=1/`p204'-`sk6' 
		local cnum=`p207'*(1/`p204')-`sk7' 
		global pb207_cor=`cnum'/`cden'
		local cnum2=$pb208*(1/`p204')-`sk8' 
		global pb208=`cnum2'/`cden'

		if pb204_206[$i] == 0 | pb204_206[$i] ==.{	
			global pb207=cor_207_206[$i]
			global pb208=cor_208_206[$i]
			}
			
end
				
