	
program define iso_rbsr_agecheck
version 10
	display
	display
	display
	display as text". ISOTOOLS by F. Bea (2007); v. 2.0"
	display
	display as text". Rb-Sr age check"
	display
	display as text". THIS PROGRAM CALCULATES 3000 TIMES THE age_rbsr AND INITIAL RATIO OF"
	display as text". SELECTED POINTS BY A WEIGHTED REGRESSION, WITH RANDOMLY GENERATED WEIGHTS"
	display as text". CONSTRAINED SO THAT ONE IS ALWAYS 0 AND OTHER IS ALWAYS 1."
	display as text". IF THE FREQUENCY PLOT IS NOT SYMMETRICAL, THE ISOCHRON age_rbsr WOULD BE WRONG"
	display as text". IT TAKES A WHILE, BE PATIENT"
	display
	display
	capture drop wt
	capture drop peso*
	capture drop age_rbsr
	capture drop slope
	capture drop intercept
	capture matrix drop A
	local n=[_N]
	if `n'>50 {
		display""
		display as error". TOO MANY OBSERVATIONS, CHECK YOUR DATA SET"
		exit
		}
	quietly {
	gen wt=uniform()
	local r 0
    local t 0
    while `r' ==`t'{
		local r=int(uniform()*`n')+1
		local t=int(uniform()*`n')+1
		}
	replace wt=1 in `r'
	replace wt=0 in `t'
	set obs 3000
	local i 0
	while `i'<`n' {/*creo las variables para almacenar los pesos*/
	local i=`i'+1
	local v "peso`i'"
	gen `v'=.
	}
	gen slope=.
	gen intercept=.
	gen age_rbsr=.
	local j 0
	while `j'<3000{
		local j=`j'+1
		replace wt=uniform()
		local r 0
        local t 0
         while `r' ==`t'{
		    local r=int(uniform()*`n')+1
			local t=int(uniform()*`n')+1
		    }
	replace wt=1 in `r'
	replace wt=0 in `t'
		reg srsr rbsr [aweight=wt] if es==1
		capture matrix drop A
		local z 0
			while `z'<`n'{
			local z=`z'+1
			local v "peso`z'"
			replace `v'=wt[`z'] in `j'	
			}
		matrix A=e(b)
		replace slope=A[1,1] in `j'
		replace intercept=A[1,2] in `j'		
		}/*del bucle j*/
		replace age_rbsr=log(1+slope)/0.0000142
		histogram age_rbsr, bin(20) bfcolor(gold) blcolor(black) normal title("Statistics of 3000 Age Calculations") xsize(6) ysize(5) yaxis(1,2) ylabel("",axis(2)) ytitle("",axis(2)) ylabel(,angle(horizontal)) xaxis(1,2) xtitle("age_rbsr (Ma)") xlabel("",axis(2)) xtitle("",axis(2)) xmtick(##5) name("Rb_Sr_age_rbsr_check", replace)
}/*del quietly*/
display as result". STATISTICS OF THE ANALYSIS"
display
display as result " Confidence intervals"
ci age_rbsr intercept
display
display as result " Summary statistics"
sum age_rbsr intercept
local n=`n' + 1
quietly{
	drop in `n'/3000
	drop wt peso* slope intercept age_rbsr
	}/* del quietly*/
display
display as text ". Done Rb-Sr age check"
end
