program define iso_sr
	version 10

	display
	display
	display
	display as text". Sr PARAMETERS - ISOTOOLS by F. Bea (2007); v. 2.0"
	display
	display
	display as text ". THIS ROUTINE NEEDS THE VARIABLES NAMED" as error" rb, sr, srsr, age (IN MILLION YEARS)"
	display
	display
	capture confirm numeric variable rb
	if _rc~=0 {
	display as error". YOU DO NOT HAVE A NUMERIC VARIABLE NAMED rb, I.E. THE PPM OF RB"
	des
	exit
	}
	capture confirm numeric variable sr 
	if _rc~=0 {
	des
	display as error". YOU DO NOT HAVE A NUMERIC VARIABLE NAMED sr, I.E. THE PPM OF SR"
	exit
	}
	capture confirm numeric variable srsr 
	if _rc~=0 {
	des
	display as error". YOU DO NOT HAVE A NUMERIC VARIABLE NAMED srsr, I.E. THE 87Sr/86Sr RATIO  "
	exit
	}
	capture confirm numeric variable age 
	if _rc~=0 {
	des
	display as error". YOU DO NOT HAVE A NUMERIC VARIABLE NAMED age, I.E. THE AGE IN MILLION YEARS  "
	exit
	}
	capture drop rbsr 
	capture drop srsr_t 
	capture drop eps_sr_t
	label var srsr "87Sr/86Sr"
	label var age Ma
	label var rb Rb
	label var sr Sr
	quietly{
		tempvar rb87 sr86 sr87 sr88 pmsr
		gen float `rb87'=rb*0.0032567391
		gen float `pmsr'=(98.72957+srsr*10.37691)/(1.12615+0.1194*srsr)
		gen float `sr86'=(sr/`pmsr')*(0.1194/(1.12615+0.1194*srsr))
		gen float `sr87'=`sr86'*srsr
		gen float rbsr=`rb87'/`sr86'
		label var rbsr "87Rb/86Sr"
		gen float srsr_t=srsr-rbsr*(exp(0.0000142*age)-1)
		label var srsr_t "87Sr/86Sr_t"
		gen float eps_sr_t=((srsr_t/(0.7045-0.0827*(exp(0.0000142*age)-1)))-1)*10000
		label var eps_sr_t "epsilon_t Sr"
	}/*del quietly*/
	display as result "Results"
	list id rb sr srsr age srsr_t eps_sr_t
	display
	display as text". Done Sr isotopes calculations"
	display
end
