program isochron_rbsr
	version 10
	
	capture drop x_err y_err resid weight

	
	display
	display
	display as text". ISOTOOLS by F. Bea (2007); v. 2.0"
	display
	display
	display as text ". Rb/Sr Isochron"
	display
	display as text". THIS ROUTINE NEEDS THE VARIABLES:" as error" -rbsr, err_rbsr, srsr, err_srsr, es-"
	display
	display as text". THE VARIABLE" as error" -es-" as text " IS 1/2 AND CONTROLS WHETHER A POINT IS INCLUDED IN THE CALCULATION (es=1)"
	display as text". THE ERRORS MAY BE EITHER PERCENTUAL OR ABSOLUTE"
	display
	
	capture confirm numeric variable rbsr
	if _rc~=0 {
	des
	display as error ". YOU DO NOT HAVE A NUMERIC VARIABLE NAMED rbsr"
	exit
	}
	capture confirm numeric variable err_rbsr
	if _rc~=0 {
	des
	display as error ". YOU DO NOT HAVE A NUMERIC VARIABLE NAMED err_rbsr"
	exit
	}
	capture confirm numeric variable srsr
	if _rc~=0 {
	des
	display as error ". YOU DO NOT HAVE A NUMERIC VARIABLE NAMED srsr"
	exit
	}
	capture confirm numeric variable err_srsr
	if _rc~=0 {
	des
	display as error ". YOU DO NOT HAVE A NUMERIC VARIABLE NAMED err_srsr"
	exit
	}
	capture confirm numeric variable es
	if _rc~=0 {
	des
	display as error". YOU DO NOT HAVE A CONTROL VARIABLE (1/2) NAMED es"
	exit
	}
	quietly replace es=. if es!=1  /*elimino las variables que no entran en el calculo, las recupero al final*/
	sort es
	local decay_cte 0.0000142
	label var rbsr "87Rb/86Sr"
	label var srsr "87Sr/86Sr"
	display""
	/*transformo el error a absoluto*/
	local e_tipo "junk"
	capture confirm number `e_tipo'
	while _rc!=0{
			display as result". Specify whether the error is percentual (1) or absolute (2) " _cont
			display _request(_e_tipo)
			capture confirm number `e_tipo'
			}
	quietly{
		if `e_tipo'==1 {
			gen x_err= err_rbsr*rbsr/100
			gen y_err=err_srsr*srsr/100
			}
			else {
			gen x_err= err_rbsr
			gen y_err=err_srsr
			}/*del if*/
			}/*del quietly*/
	/*fin transformacion a absoluto*/
	
	/*aplico el nivel de sigma*/	
	display""
	local sigma "junk"
	capture confirm number `sigma'
	while _rc!=0{
			display as result". Input the sigmas for the error (1 or 2) " _cont
			display _request(_sigma)
			capture confirm number `sigma'
			}
		quietly{
			replace x_err= x_err/`sigma'
			replace y_err=y_err/`sigma'
			}/*del quietly*/

	local nobs=_N
	local i 0
	local n 0
	while `i'<`nobs' {
		local i= `i'+1
		if es[`i']==1 local n= `n'+1
		}/*n es el numero de muestras para calculo*/
	
	quietly {
	regress srsr rbsr if es==1
	predict double resid,residuals
	matrix A=e(b)
	local slope A[1,1]
	local intercept A[1,2]
	gen double weight=1/((`slope'*x_err)^2 + (y_err)^2) if es==1
	  }
	local s 0
	local x_c 0
	local y_c 0
	local w 0
	local i 0 /*calculo la desviacion*/
	while `i'<`n'{
		local i=`i'+1
		local s=`s'+weight[`i']*(resid[`i']^2)
		local w=`w'+weight[`i']
		local x_c=`x_c'+weight[`i']*rbsr[`i']
		local y_c=`y_c'+weight[`i']*srsr[`i']
		}
	local x_c `x_c'/`w'
	local y_c `y_c'/`w'
	local s2=`s'*10000/*para hace el bucle una vez*/
	while `s2'>`s'{
	local s2=`s'
	/*calculo la pendiente*/
	local b_num 0
	local b_den 0
	local a 0
	local i 0
	while `i'<`n' {
		local i=`i'+1
		local b_num=`b_num'+ weight[`i']*(srsr[`i']-`y_c')*(((y_err[`i'])^2)*(rbsr[`i']-`x_c')+((x_err[`i'])^2)*`slope'*(srsr[`i']-`y_c'))
		local b_den=`b_den'+ weight[`i']*(rbsr[`i']-`x_c')*((y_err[`i']^2)*(rbsr[`i']-`x_c')+(x_err[`i']^2)*`slope'*(srsr[`i']-`y_c'))
		}	
		local slope `b_num'/`b_den'
	/*calculo la intercepcin*/	
	local intercept: display %10.9f `y_c'-`slope'*`x_c'
	/*calculo los nuevos residuales, pesos y s*/
	local s 0
	local i 0
	local x_c 0
	local y_c 0
	local w 0
	while `i'<`n'{
		local i=`i'+1
		quietly replace resid=(srsr[`i']-`slope'*rbsr[`i']-`intercept') in `i'
		quietly replace weight=(1/((`slope'*x_err[`i'])^2 + (y_err[`i'])^2)) in `i'
		local s=`s'+weight[`i']*(resid[`i']^2)
		local w=`w'+weight[`i']
		local x_c=`x_c'+weight[`i']*rbsr[`i']
		local y_c=`y_c'+weight[`i']*srsr[`i']
		}
	local x_c `x_c'/`w'
	local y_c `y_c'/`w'
	}
	local ms = `s'/(`n'-2)
	local b_err 0
	local a_err 0
	local i 0
	while `i'<`n'{
		local i=`i'+1
		local b_err=`b_err'+(weight[`i']*(rbsr[`i']-`x_c')^2)
		local a_err=`a_err'+ weight[`i']*(rbsr[`i']^2)
		}
		
	local mswd: display %9.2f `ms'
	local init_mswd=`mswd'
	local b_err=sqrt(1/`b_err')
	local a_err=sqrt(`b_err'^2*`a_err'/`w')
	local b_err_ex=`b_err'*sqrt(`ms')*invttail(`n'-2,0.05) /*calculo de errores expandidos, mult. mswd y t factor*/
	local a_err_ex=`a_err'*sqrt(`ms')*invttail(`n'-2,0.05)
	local age: display %9.1f log(1+`slope')/(`decay_cte')
	local error_b: display %9.1f log(1+`b_err_ex')/(`decay_cte')
	
	display
	display as result".          RESULTS OF ISOCHRON CALCULATIONS:"
	display
	display as result "MODEL 1, IMPLEMENTED AFTER YORK (1969). ERRORS ARE EXPANDED BY SQRT(MSWD) AND"
	display as result "A STUDENT'S t FACTOR FOR 95% PROB. AND N-2 DEGREES OF FREEDOM"
	display
	display as result". SLOPE = " `slope' "    INTERCEPT=   "`intercept'
	display as result". AGE = " `age' "  "`error_b' " Ma"
	local init_ratio: display %9.6fc `intercept'
	local error_a:display %9.6fc `a_err_ex'
	display as result". INTERCEPT = " `init_ratio' "  " `error_a'
	display as result". MSWD= " `mswd'
	
	if `ms' < 1+2*sqrt(2/(`n'-2)){
		quietly{
		local npuntos= _N+1
			set obs `npuntos'
			replace rbsr=0 in `npuntos'
			replace es=1 in `npuntos'
			gen est=rbsr*`slope'+`intercept' if es==1
			}
		sort rbsr
		local la_edad= "Age = "+ string(`age')+ "  "+string(`error_b') + " Ma"+"; "
		local la_mswd="MSWD= "+string(`mswd')
	
		local la_inicial= "87Sr/86Sr init.= "+ string(`init_ratio')+"  "+string(`error_a')+"; "
		twoway (scatter srsr rbsr) (lfit est rbsr) if es==1, xsize(5) ysize(4) ytitle(87Sr/86Sr) ylabel(#5, labsize(small) angle(horizontal) format(%9.3f)) ymtick(##5, nolabels) xlabel(#5, labsize(small) format(%9.1f)) xmtick(##5) title("Isochron plot, model 1") note(`la_edad'  `la_inicial'  `la_mswd', size(small) position(12) orientation(horizontal) box bexpand justification(center)) legend(off) plotregion(lcolor(black))
		quietly{
		capture drop in 1
		}
		capture drop resid
		capture drop est 
		capture drop weight
		capture drop x_err
		capture drop y_err
		display
		display as result" errors are expanded by the square root of the MSWD and a Student's t factor"
		display as result " for n-2 degrees of freedom and a probability of 0.95"
		display as text "*****************************end *****************************"
		exit
		}
	else{
		display""
		display as error "WARNING:"
		display as error "The fitted line is an errorchrone and might not produce acceptable results. Use model 3."
		display
		capture drop resid
		capture drop est
		capture drop weight_dev 
		capture drop weight
		capture drop weight_a
		capture drop deviation
		quietly{
			reg srsr rbsr if es==1
			predict double resid if es==1,residuals
			gen weight_dev=1/(resid^2) if es==1
			sum weight_dev
			replace weight_dev=1+weight_dev/r(max)
			capture matrix drop A
			matrix A=e(b)
			local slope A[1,1]
			local intercept A[1,2]
			local b_err_ex 2*_se[rbsr]
			local a_err_ex 2*_se[_cons]
			gen double weight=1/((`slope'*x_err)^2 + (y_err)^2) if es==1
			gen deviation=weight*(resid^2) if es==1
			sum deviation if es==1
			}
			local mswd=r(sum)/(`n'-2)
			local mswd2=`mswd'
			local control=`mswd'*2
			/*inicio el bucle*/
				while `mswd'<`control'{
			local control=`mswd'
			drop resid
			matrix drop A
			quietly{
			reg srsr rbsr [aweight=weight_dev]
			predict double resid if es==1,residuals
			replace weight_dev=1/(resid^2) if es==1
			sum weight_dev
			replace weight_dev=1+weight_dev/r(max)
			matrix A=e(b)
			local slope A[1,1]
			local intercept A[1,2]
			local b_err_ex=2*_se[rbsr]
			local a_err_ex=2*_se[_cons]
			replace weight=1/((`slope'*x_err)^2 + (y_err)^2) if es==1
			replace deviation=weight*(resid^2) if es==1
			sum deviation if es==1
			}
					if `mswd2' >`mswd' {
			local mswd2=`mswd'
			}
			local mswd=r(sum)/(`n'-2)
					}/*fin del bucle*/
		
			quietly{
			predict est if es==1,xb
			}
			local f 0
			local mswd=`mswd2'
		
			while `mswd'>1{
				local f=`f'+0.0000001/*f es la varianza de intercept para que mswd0 1*/
			quietly{
			replace weight=1/(`f'+(`slope'*x_err)^2 + (y_err)^2) if es==1
			replace deviation =weight*(resid^2) if es==1
			sum deviation
			local mswd=r(sum)/(`n'-2)
			}
		}

	local age: display %9.1f log(1+`slope')/(`decay_cte')
	local b_err2=`b_err_ex' + `b_err'*invttail(`n'-2,0.025)
	local error_b: display %9.1f log(1+`b_err2')/(`decay_cte')
	local a_err2=`a_err_ex'+`a_err'*invttail(`n'-2,0.025)
	local a_err3=sqrt(`f')*2
	local err_init:display %9.6f `a_err3'
	local err_intercept:display %9.6f `a_err2'
		
	display
	display as result "MODEL 3: EXCESS OF SCATTER DISTRIBUTED BETWEEN THE INITIAL RATIO VARIATION AND POINT"
	display as result "DISPERSION FROM THE REGRESSION LINE"
	display
	display	as result "The following implements the Model 3,excess of scatter, using a weighted regression"
	display as result "iterative method. Weighths are = 1/ residual^2. The iteration is to minimize the MSWD."
	display as result "Afterwards the inherent variation of initial ratio is calculated using the "
	display	as result "algorithm of McIntyre et al. (1966) Errors are the sum of the analytical error, expanded"
	display	as result "by a Student's t factor (n-2 d.o.f, alfa 0.025) plus the curve fitting error (95% conf. int.)"
	display
	display as result". SLOPE = " `slope' "    INTERCEPT=   "`intercept'
	display as result". AGE = " `age' "  "`error_b' " Ma"
	local init_ratio: display %9.6f `intercept'
	display as result". INTERCEPT = " `init_ratio' "  " `err_intercept'
	display as result". INITIAL ISOTOPE RATIO VARIATION= " `err_init'
	display as result". MSWD = "`init_mswd'
	display
	display as error "It is advisable to check the model with the routine Rb-Sr isochron age check"
	
	quietly{
		local npuntos= _N+1
			set obs `npuntos'
			replace rbsr=0 in `npuntos'
			replace es=1 in `npuntos'
			replace est=rbsr*`slope'+`intercept' if es==1
			}
		sort rbsr
		local la_mswd="MSWD= " + string(`init_mswd')
		local la_edad= "Age = " + string(`age')+ "  "+string(`error_b') + " Ma"+"; "
		
		local la_inicial= "87Sr/86Sr init.= "+ string(`init_ratio')+"  "+string(`err_intercept')+"; "
		local la_initvar="87Sr/86Sr init var.= "+ string(`err_init')+"; "
		twoway (scatter srsr rbsr) (lfit est rbsr) if es==1, xsize(5) ysize(4) ytitle(87Sr/86Sr) ylabel(#5, labsize(small) angle(horizontal) format(%9.3f)) ymtick(##5, nolabels) xlabel(#5, labsize(small) format(%9.1f)) xmtick(##5) title("Isochron plot, model 3") note(`la_edad'  `la_inicial'  `la_mswd', size(small) position(12) orientation(horizontal) box bexpand justification(center)) legend(off) plotregion(lcolor(black))
		quietly{
		capture drop in 1
		capture drop resid
		capture drop est
		capture drop weight
		capture drop weight_dev
		capture drop deviation
		capture drop x_err
		capture drop y_err
			}
		display as text ". Done Rb/Sr isochron"
		}/*del else*/

end
